#include "Zeit.h"

uint8_t Monatstage[2][12]={{31,28,31,30,31,30,31,31,30,31,30,31},{31,29,31,30,31,30,31,31,30,31,30,31}};


uint8_t Schaltjahr(uint16_t Jahr){
 if ((Jahr%4==0)&&((Jahr%100!=0)||(Jahr%400==0))) return 1;
 return 0;                 
};


void Zeitaktualisierung(void){
 Jetzt.Sekunden++;
 if (Jetzt.Sekunden==60){
  Jetzt.Sekunden=0;
  Jetzt.Minuten++;
  if (Jetzt.Minuten==60){
   Jetzt.Minuten=0;
   Jetzt.Stunden++;
   Vollestunde=1;
   if (Jetzt.Stunden==24){
    Jetzt.Stunden=0;
	Jetzt.Tag++;
	if (Jetzt.Tag==Monatstage[Schaltjahr(Jetzt.Jahr)][Jetzt.Monat-1]+1){
	 Jetzt.Tag=1;
	 Jetzt.Monat++;
	 if (Jetzt.Monat==13){
	  Jetzt.Monat=1;
	  Jetzt.Jahr++;
	 };
    };
   };
  };
 };
};


void init_timer(void){
 TCCR1B = 1<<WGM12 | 1<<CS10;  //Clear Timer on Compare Match, clkI/O/1 (No prescaling)
 OCR1A = (XTAL / VORTEILER - 1);    // Output Compare Register = Quarzfrequenz/Softwareteiler -1
 TCNT1 = 0;                    // Timmer startet mit 0
 Prescaler = (uint8_t) VORTEILER; //software teiler
 TIMSK = 1<<OCIE1A;
}


ISR(SIG_OUTPUT_COMPARE1A){
 #if XTAL % VORTEILER
  OCR1A = XTAL / VORTEILER - 1;
 #endif
 if( --Prescaler == 0 ){
  Prescaler = (uint8_t) VORTEILER;
  Zeitaktualisierung();
 #if XTAL % VORTEILER
  OCR1A = XTAL / VORTEILER + XTAL % VORTEILER - 1;
 #endif
  }
}
