#ifndef _Zeit_H
#define _Zeit_H

#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdint.h>

 
#define XTAL   8000000L
 
#define VORTEILER 256L		// Softwareteiler (256Hz = 4msec)

typedef struct{
 uint8_t Sekunden;
 uint8_t Minuten;
 uint8_t Stunden;
 uint8_t Tag;
 uint8_t Monat;
 uint16_t Jahr;
} Zeit;


uint8_t Schaltjahr(uint16_t Jahr);
void Zeitaktualisierung(void);
void init_timer(void);
ISR(SIG_OUTPUT_COMPARE1A);

uint8_t Prescaler;
volatile extern Zeit Jetzt;
volatile extern uint8_t Vollestunde;

#endif
